# -*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""

__script__ = 'PyPostblog'
__version__ = '0.01(0)'
__author__ = 'masa'
__web__ = 'http://masaland.cocolog-nifty.com/'
__copyright__ = '(C) 2014 masa'

import sys
if not hasattr(sys, "setdefaultencoding"):
    wk = sys.stdout
    reload(sys)
    sys.stdout = wk
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

import os
import appuifw
import e32
import re
import smtplib
from email.Header import Header
from email.MIMEMultipart import MIMEMultipart
from email.MIMEText import MIMEText
from email.MIMEImage import MIMEImage
from email.Encoders import encode_base64 

#----------------------------------------------
IN_PATH_TXT = 'E:\\Data\\fubuki_html\\'
IN_PATH_IMG = 'E:\\Data\\fubuki_html\\photo\\'

To_adr_dic = {'toad1':'"toad1" <aaa@aaaaa.jp>' ,
              'toad1':'"toad1" <bbb@bbbbb.jp>' ,
              'toad3':'"toad3" <ccc@ccccc.jp>'
              }
My_adr = '"myname" <myad@my_server.jp>'
Host = 'mail.mymail_server.jp'
Port = 587
login_id = 'my_id'
login_pw = 'my_pw'
#-----------------------------------------------

LISTBOX = ''
lock = e32.Ao_lock()


def set_menu():
    appuifw.app.title = unicode(__script__ + ' ' + __version__)
    appuifw.app.exit_key_handler = do_exit #lambda:do_dummy()
    appuifw.app.menu = [(u'Send', main),
                        (u'About', about),
                        (u'Exit', do_exit)]


def show_msg(msg=' '):
    global LISTBOX
    #* for Python 2.0
    list_wk = [u' ', u' ']
    LISTBOX.set_list(list_wk, 0)
    #
    list_wk = [unicode(__script__ + ' V' + __version__, 'UTF-8')]
    list_wk.append(unicode(msg))
    LISTBOX.set_list(list_wk, 1)


def do_dummy():
    pass


def do_exit():
    lock.signal()


def about():
    msg = '%s\nVer_%s\n%s\n%s' % (__script__, __version__, __copyright__, __web__)
    appuifw.query(unicode(msg, "utf-8"), "query")


def makemail(subjstr,toaddr,body):
    outer = MIMEMultipart()
    subj = Header(subjstr)
    outer["Subject"] = subj
    outer["From"] = My_adr
    outer["To"] = toaddr
#    mainpart = MIMEText("",_charset = "iso-2022-jp")
#    mainpart.set_payload(body.encode("iso-2022-jp"))
    mainpart = MIMEText("",_charset = "UTF-8")
    mainpart.set_payload(body.encode("UTF-8"))
    encode_base64(mainpart) 

    outer.attach(mainpart)
    return outer


def make_attachment(filename):
    F_path = os.path.join(IN_PATH_IMG , filename)
    F = open(F_path,'rb')
    FData = F.read()
    F.close()

    attachment = MIMEImage(FData, 'jpg', name=filename)
    attachment.set_payload(FData)
    encode_base64(attachment)

    return attachment


def main():

    wk_list = To_adr_dic.keys()
    wk_list.sort()
    Key_list = [x.decode('utf-8') for x in wk_list ]
    idx = appuifw.selection_list(choices=Key_list)
    if idx == None:
        show_msg('Canceled')
        return

    To_adr_key = Key_list[idx]
    To_adr = To_adr_dic[To_adr_key]

    filelist = [x.decode('utf-8') for x in os.listdir(IN_PATH_TXT) \
				if ((os.path.splitext(x)[1]).lower()[:4]=='.txt') or \
                   ((os.path.splitext(x)[1]).lower()[:4]=='.htm') or \
                   ((os.path.splitext(x)[1]).lower()[:4]=='.tex')]
    filelist.sort()
    idx = appuifw.selection_list(choices=filelist,search_field=1)
    if idx == None :
        show_msg('Canceled')
        return
    S_sub = str(appuifw.query(u'Mail Subject','text'))
    if S_sub == None :
        show_msg('Canceled')
        return
    S_sub = unicode(S_sub)

    F_path = os.path.join(IN_PATH_TXT , filelist[idx])
    F = open(F_path,'r')
    FData = unicode(F.read())
    F.close()

    outer = makemail(S_sub,To_adr,FData)

    # attach image(jpg) file
    if appuifw.query(u'Attach image?','query'):
        filelist = [x.decode('utf-8') for x in os.listdir(IN_PATH_IMG) \
                    if (os.path.splitext(x)[1]).lower()[:3]=='.jp']
        filelist.sort()
        idx = appuifw.multi_selection_list(filelist)
        if idx:
            for n in idx:
                attachment = make_attachment(filelist[n])
                if attachment:
                    outer.attach(attachment)

    if appuifw.query(u'Send ?\n  OK:send\n  Cancel:cancel','query'):
        S = smtplib.SMTP(Host,Port)
        S.login(login_id,login_pw)
        S.sendmail(My_adr,To_adr,outer.as_string())
        S.quit
        show_msg('sent to %s' % To_adr_key)
    else:
        show_msg('Canceled')


def run():
    global LISTBOX

    old_title = appuifw.app.title
    list_wk = [unicode(__script__ + ' V' + __version__, 'UTF-8')]
    LISTBOX = appuifw.Listbox(list_wk, do_dummy)
    appuifw.app.body = LISTBOX
    set_menu()

    lock.wait()
    appuifw.app.title = old_title


if __name__ == '__main__':
    run()
#    appuifw.app.set_exit()
#    sys.exit()


